package cn.com.qmth.examcloud.core.oe.admin.service.impl;

import cn.com.qmth.examcloud.api.commons.security.bean.UserDataRule;
import cn.com.qmth.examcloud.core.oe.admin.base.jpa.SpecUtils;
import cn.com.qmth.examcloud.core.oe.admin.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.admin.dao.ReexamineLogRepo;
import cn.com.qmth.examcloud.core.oe.admin.dao.entity.ReexamineLogEntity;
import cn.com.qmth.examcloud.core.oe.admin.service.ReexamineLogService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.reexaminelog.ReexamineLogInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.reexaminelog.ReexamineLogQuery;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

@Service
public class ReexamineLogServiceImpl implements ReexamineLogService {

    private static final Logger log = LoggerFactory.getLogger(ReexamineLogServiceImpl.class);

    @Autowired
    private ReexamineLogRepo reexamineLogRepo;

    @Override
    public void addReexamineLog(ReexamineLogEntity reexamineLog) {
        if (reexamineLog == null) {
            return;
        }

        reexamineLogRepo.save(reexamineLog);
        log.warn("重考设置！examId:{} examStudentId:{} {} {}", reexamineLog.getExamId(), reexamineLog.getExamStudentId(),
                reexamineLog.getReexamineType(), reexamineLog.getReexamineDetail());
    }

    @Override
    public Page<ReexamineLogInfo> getReexamineLogList(ReexamineLogQuery query, UserDataRule courseRule, UserDataRule orgRule) {
        Check.isNull(query, "请求参数不能为空！");
        Check.isNull(query.getExamId(), "请先选择考试！");

        Pageable pageable = SpecUtils.buildPageable(query.getPageNo(), query.getPageSize());
        //todo

        return Page.empty(pageable);
    }

}
